cryptonite-0.26: Cryptography Primitives sink

License | BSD-style
Maintainer | Carlos Rodriguez-Vega <crodveg@yahoo.es>
Stability | experimental
Portability | unknown
Safe Haskell | None
Language | Haskell2010

Crypto.PubKey.Rabin.Modified

Description

Modified-Rabin public-key digital signature algorithm. See algorithm 11.30 in "Handbook of Applied Cryptography" by Alfred J. Menezes et al.

Synopsis

- data PublicKey = PublicKey {
  - public_size :: Int
  - public_n :: Integer
  }
- data PrivateKey = PrivateKey {
  - private_pub :: PublicKey
  - private_p :: Integer
  - private_q :: Integer
  - private_d :: Integer
  }
- generate :: MonadRandom m => Int -> m (PublicKey, PrivateKey)
- sign :: HashAlgorithm hash => PrivateKey -> hash -> ByteString -> Either Error Integer
- verify :: HashAlgorithm hash => PublicKey -> hash -> ByteString -> Integer -> Bool

# Documentation

data PublicKey Source #

Represent a Modified-Rabin public key.

Constructors

PublicKey |

Fields

- public_size :: Int

  size of key in bytes

- public_n :: Integer

  public p*q

#### Instances

Instances details

Eq PublicKey Source # |
Instance details Defined in Crypto.PubKey.Rabin.Modified Methods (==) :: PublicKey -> PublicKey -> Bool # (/=) :: PublicKey -> PublicKey -> Bool #
Data PublicKey Source # |

Instance details

Defined in Crypto.PubKey.Rabin.Modified

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> PublicKey -> c PublicKey #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c PublicKey #

toConstr :: PublicKey -> Constr #

dataTypeOf :: PublicKey -> DataType #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c PublicKey) #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c PublicKey) #

gmapT :: (forall b. Data b => b -> b) -> PublicKey -> PublicKey #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> PublicKey -> r #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> PublicKey -> r #

gmapQ :: (forall d. Data d => d -> u) -> PublicKey -> [u] #

gmapQi :: Int -> (forall d. Data d => d -> u) -> PublicKey -> u #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> PublicKey -> m PublicKey #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> PublicKey -> m PublicKey #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> PublicKey -> m PublicKey #

Read PublicKey Source # |
Instance details Defined in Crypto.PubKey.Rabin.Modified Methods readsPrec :: Int -> ReadS PublicKey readList :: ReadS [PublicKey] readPrec :: ReadPrec PublicKey readListPrec :: ReadPrec [PublicKey]
Show PublicKey Source # |
Instance details Defined in Crypto.PubKey.Rabin.Modified Methods showsPrec :: Int -> PublicKey -> ShowS # show :: PublicKey -> String # showList :: [PublicKey] -> ShowS #

data PrivateKey Source #

Represent a Modified-Rabin private key.

Constructors

PrivateKey |

Fields

- private_pub :: PublicKey
- private_p :: Integer

  p prime number

- private_q :: Integer

  q prime number

- private_d :: Integer

#### Instances

Instances details

Eq PrivateKey Source # |
Instance details Defined in Crypto.PubKey.Rabin.Modified Methods (==) :: PrivateKey -> PrivateKey -> Bool # (/=) :: PrivateKey -> PrivateKey -> Bool #
Data PrivateKey Source # |

Instance details

Defined in Crypto.PubKey.Rabin.Modified

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> PrivateKey -> c PrivateKey #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c PrivateKey #

toConstr :: PrivateKey -> Constr #

dataTypeOf :: PrivateKey -> DataType #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c PrivateKey) #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c PrivateKey) #

gmapT :: (forall b. Data b => b -> b) -> PrivateKey -> PrivateKey #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> PrivateKey -> r #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> PrivateKey -> r #

gmapQ :: (forall d. Data d => d -> u) -> PrivateKey -> [u] #

gmapQi :: Int -> (forall d. Data d => d -> u) -> PrivateKey -> u #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> PrivateKey -> m PrivateKey #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> PrivateKey -> m PrivateKey #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> PrivateKey -> m PrivateKey #

Read PrivateKey Source # |
Instance details Defined in Crypto.PubKey.Rabin.Modified Methods readsPrec :: Int -> ReadS PrivateKey readList :: ReadS [PrivateKey] readPrec :: ReadPrec PrivateKey readListPrec :: ReadPrec [PrivateKey]
Show PrivateKey Source # |
Instance details Defined in Crypto.PubKey.Rabin.Modified Methods showsPrec :: Int -> PrivateKey -> ShowS # show :: PrivateKey -> String # showList :: [PrivateKey] -> ShowS #

generate :: MonadRandom m => Int -> m (PublicKey, PrivateKey) Source #

Generate a pair of (private, public) key of size in bytes. Prime p is congruent 3 mod 8 and prime q is congruent 7 mod 8.

sign Source #

Arguments

:: HashAlgorithm hash |
=> PrivateKey | private key
-> hash | hash function
-> ByteString | message to sign
-> Either Error Integer |

Sign message using hash algorithm and private key.

verify Source #

Arguments

:: HashAlgorithm hash |
=> PublicKey | public key
-> hash | hash function
-> ByteString | message
-> Integer | signature
-> Bool |

Verify signature using hash algorithm and public key.